#!/perl
use warnings;
use LWP::Simple;
use LWP::UserAgent;

# shamelessly reversed engineered from a python script :-) 

print "startring first page retrieval\n";
my $urlin  = shift || "http://youtube.com/watch?v=EkTpUxh8Vxc";
my $content = get( $urlin  ) or die "$!\n"; 
my $filename = '';
my $tubename = '';
my $getname = '';

print "done first page retrieval\n";
## print $content;

# regex for 2 key text strings which identify the video file
# the second one $2 is unique for each download attempt
##$content =~ /player2\.swf\?video_id=([^&]+)&.*t=([^&]+)&/;
$content =~ /<title>(.*)<\/title>/ ;
if ($1 && length(%1)) {
    $filename = $1;
}

$content =~ /watch_fullscreen\?video_id=([^&]+)&.*t=([^&]+)&/ ;
if ($1 && length(%1)) {
    $tubename = $1;
}
if ($2 && length($2)) {
    $getname = $2;
}
print $filename, "\n" , $tubename, "\n", $getname, "\n";  
my $infile = $filename.'.flv';  #add a .flv extension

if ((length($filename) == 0)||(length($tubename)==0)) {
    print "FAILED to get video file name ...\n";
    exit(0);
}
#http://www.youtube.com/get_video?video_id=p_YMigZmUuk&t=OEgsToPDskLRl9-iKyfQVcNT8xes2OIT
#my $get_url = 'http://www.youtube.com/get_video?video_id='.$filename.'&t='.$getname;
my $get_url = 'http://www.youtube.com/get_video?video_id='.$tubename.'&t='.$getname;

print "gettin video file $get_url\n";

# don't buffer the prints to make the status update
$| = 1;

open(IN,"> $infile") or die "$_\n"; 
binmode(IN);

my $ua = LWP::UserAgent->new();
my $received_size = 0;
my $url = $get_url;
print "Fetching $url\n";
my $request_time = time;
my $last_update = 0;
my $response = $ua->get($url,
                        ':content_cb'     => \&callback,
                        ':read_size_hint' => 8192,
                       );
print "\n";
close IN;

#play the flv file with mplayer
#system( "mplayer $infile" );
if ($received_size > 0) {
    system( "$infile" );
} else {
    print "ERROR: No data received ...\n";
}
exit(0);

#############################################

sub callback {
  my ($data, $response, $protocol) = @_;

  my $total_size = $response->header('Content-Length') || 0;
  $received_size += length $data;

  # write the $data to a filehandle or whatever should happen
  # with it here.
  print IN $data;

  my $time_now = time;

  # this to make the status only update once per second.
  return unless $time_now > $last_update or $received_size == $total_size;
  $last_update = $time_now;

  print "\rReceived $received_size bytes";
  printf " (%i%%)", (100/$total_size)*$received_size if $total_size;
  printf " %6.1f/bps", $received_size/(($time_now-$request_time)||1)
     if $received_size;
}

# eof
